import java.util.*;

public class RandomDoublyLinkedList  {
	
  public static void main (String[ ] args) {
     new RandomDoublyLinkedList().run();
  } // method main


  /** generazione lista casuale in ordine naturale crescente di dim interi 
   *  nell'intervallo [minimum e maximum] 
   **/
  public SortedDoublyLinkedList<Integer> RandList(int dim, int min, int max) {
 
	Random rand = new Random ();
	SortedDoublyLinkedList<Integer> randList = new SortedDoublyLinkedList<Integer>( ); //lista vuota

  	for (int i = 0; i < dim; i++)
  	// NB: nextInt(int n) restituisce un intero random in [0,n-1] 
  	randList.insert(rand.nextInt((max - min) + 1) + min);
	return randList;
  }

  /** generazione lista casuale in ordine crescente (rispetto ad un comparatore) di dim interi 
   *  nell'intervallo [minimum e maximum] 
   **/
  public SortedDoublyLinkedList<Integer> RandList(int dim, int min, int max, Comparator<Integer> c) {
  // generazione lista casuale in ordine decrescente di dim interi nell'intervallo [minimum e maximum] 
 
	Random rand = new Random ();
	SortedDoublyLinkedList<Integer> randList = new SortedDoublyLinkedList<Integer>(c); //lista vuota

  	for (int i = 0; i < dim; i++)
  	// NB: nextInt(int n) restituisce un intero random in [0,n-1] 
  	randList.insert(rand.nextInt((max - min) + 1) + min);
	return randList;
  }


  public void run(){

     	/**** GENERAZIONE LISTE CASUALI ****/

 
	// generazione random di una lista di interi in ordine crescente
	  SortedDoublyLinkedList<Integer> randList = RandList(10, 1, 100);	  
	System.out.println("randList:\t" + randList);


	// generazione random di una lista di interi in ordine decrescente
	SortedDoublyLinkedList<Integer> randListDecr = RandList(10, 1, 100,
     			new Decreasing());
	System.out.println("randListDecr:\t" + randListDecr);

	/**** TEST METODI DI BASE ****/	
	Random r = new Random ();
	int n = r.nextInt(100);
	randList.insert(n);
	randListDecr.insert(n);
	System.out.println("\nDopo l'inserimento di " + n);	
	System.out.println("randList:\t" + randList);
	System.out.println("randListDecr:\t" + randListDecr);



	/**** TEST COPIA, RICERCA ELEMENTO, REMOVE, VERIFICA DI UGUAGLIANZA ****/

	SortedDoublyLinkedList<Integer> copyList = randList.copy();
	System.out.println("\nCopia di randList (copyList):\n" + copyList);	
	if (!randList.equals(copyList)) System.out.println("Errore nella copia della lista");
	else System.out.println("Copia eseguita correttamente!");

	System.out.println("\nDopo una cancellazione del primo elemento da copyList");	
	Integer item = copyList.remove(0);
        System.out.println(copyList);
	if (randList.equals(copyList)) System.out.println("Errore nella cancellazione di un elemento");
	else System.out.print("Ora randList e copyList sono diverse: ");
	if (! copyList.contains(item)) System.out.println(item + " non e' piu' in copyList");
	else System.out.println("Errore nella cancellazione del terzo elemento di copyList.");

	copyList.insert(50);
        System.out.println("\nDopo l'inserimento di 50 in copyList:\n" + copyList);
        if (copyList.removeRec((Integer)50))
            System.out.println("\nDopo la cancellazione di 50 da copyList:\n" + copyList);

        if (!copyList.removeRec((Integer)200))  //nessuna cancellazione
            System.out.println("\n200 non e' presente in copyList");

	/**** ORDINAMENTO: INSERTIONSORT ****/
	System.out.println("\ncopyList in ordine decrescente (insertionSort):\n" + copyList.insertionSort(new Decreasing()));
	System.out.println("\ncopyList e' sempre:\n" + copyList);

	/**** SET COMPARATOR ****/
	randList.setComparator(new Decreasing());  //invoca insertionSort
	System.out.println("\nOra randList e' (in ordine decrescente):\n" + randList);



        
 } // method run

} // class RandomDoublyLinkedList



class Decreasing implements Comparator<Integer> 
 {
  /**
   *  Compares two specified Integer objects. 
   *
   *  @param i1  one of the Integer objects to be compared.
   *  @param i2  the other Integer object.
   *
   *  @return the value of i2s int  the value of i1s int.
   *
   */
      public int compare (Integer i1, Integer i2) 
  {
           return i2.compareTo (i1);
      } // method compare

 } // class Decreasing
